program ChaosGenerator;

uses Windows, Graphics, messages, mmsystem;

const vol = 600; //

type
  trgb = record
   b,g,r: byte;
  end;

  ARGB = array [0..0] of TRGB;

  PARGB = ^ARGB;

var wc:TWndClassEx;
    MainWnd:THandle;
    Mesg:TMsg;
    b:tbitmap;
    pb:array of PARGB;            
    Thr,i: LongWord;
    tem:array [0..255] of trgb;
    trig:boolean;
    dc:hdc;
    data:array [0..1] of array of word;
    trig2:boolean;
    Thr2: LongWord;
    Channels,Resolution:word;
    po1:tWaveFormatEx;
    po:array [0..1] of wavehdr_tag;
    BytesPerSecond, SampleRate, DataBytes: LongInt;
    z1:integer; //
    siz:cardinal;
    Event1: thandle;

procedure CalcProc;
 var i,j,k,l:integer;
begin
 k:=b.Height-1;
 l:=b.Width-1;
 while trig do begin
  for i:=0 to k do
   for j:=0 to l do
    pb[i,j]:=tem[random(256)];
  dc:=getdc(MainWnd);
  bitblt(dc,0,0,b.Width,b.Height,b.Canvas.Handle,0,0,srccopy);
  ReleaseDC(MainWnd,dc);
 end;
end;

function Doedin(x:extended):integer; // 
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure PlayProc;
 var i,j:integer;
begin
 j:=1;
 while trig do begin
  WaitForSingleObject(Event1,INFINITE);
  for i:=0 to high(data[j]) do    //  
   data[j][i]:=doedin(vol*random);
  waveOutWrite(z1,@po[j],siz);    // 
  j:=1 xor j;
 end;
end;

function WindowProc(wnd:HWND; Msg:Integer; Wparam:Wparam; Lparam:Lparam): Longint; stdcall;
begin
 Result:=0;
 case msg of
 wm_keydown : postmessage(MainWnd,wm_destroy,0,0);
 wm_lbuttondown : postmessage(MainWnd,wm_destroy,0,0);
 wm_destroy : begin
  trig:=false;
  waveOutReset(z1);
  trig2:=false;
  waveOutUnprepareHeader(z1,@po[0],sizeof(po[0]));
  waveOutUnprepareHeader(z1,@po[1],sizeof(po[1]));
  waveOutClose(z1);
  sleep(50);
  b.Free;
  invalidaterect(0,nil,false);
  unregisterclass('ChaosGenerator',hinstance);
  postquitmessage(0);
 end;
 else Result:=DefWindowProc(wnd,msg,wparam,lparam);end;
end;

BEGIN
 b:=tbitmap.Create;
 b.PixelFormat:=pf24bit;
 b.Width:=GetSystemMetrics(SM_CXSCREEN);
 b.Height:=GetSystemMetrics(SM_CYSCREEN);
 setlength(pb,b.Height);
 for i:=0 to b.Height-1 do pb[i]:=b.scanline[i];
 for i:=0 to 255 do begin tem[i].r:=i; tem[i].g:=i; tem[i].b:=i; end;
 wc.cbSize:=sizeof(wc);
 wc.lpfnWndProc:=@WindowProc;
 wc.hCursor:=LoadCursor(0,idc_arrow);
 wc.lpszClassName:='ChaosGenerator';
 RegisterClassEx(wc);
 MainWnd:=CreateWindowEx(WS_EX_TOOLWINDOW,'ChaosGenerator','',0,0,0,b.Width,b.Height,0,0,Hinstance,nil);
 SetWindowLong(MainWnd,GWL_STYLE,GetWindowLong(MainWnd,GWL_STYLE) and (not WS_CAPTION));  //   

 Channels:=1;
 SampleRate:=44100;
 Resolution:=16;

 BytesPerSecond:=Channels*SampleRate*Resolution div 8;
 DataBytes:=6400*(Resolution div 8)*Channels;

 po1.wFormatTag:=WAVE_FORMAT_PCM;
 po1.nChannels:=Channels;
 po1.nSamplesPerSec:=SampleRate;
 po1.nAvgBytesPerSec:=BytesPerSecond;
 po1.nBlockAlign:=channels*(resolution div 8);
 po1.wBitsPerSample:=Resolution;
 po1.cbSize:=0;

 Event1:=CreateEvent(nil, false, false, nil);
 waveOutOpen(@z1,0,@po1,Event1,0,CALLBACK_EVENT);

 siz:=sizeof(po[0]);
 randomize;

 for Thr:=0 to 1 do begin
  setlength(data[Thr],DataBytes div (Resolution div 8));
  fillmemory(@po[Thr],siz,0);
  po[Thr].lpData:=@data[Thr][0];
  po[Thr].dwBufferLength:=DataBytes;
  waveOutPrepareHeader(z1,@po[Thr],siz);
  for i:=0 to high(data[Thr]) do   // 
   data[Thr][i]:=doedin(vol*random);
 end;

 waveOutWrite(z1,@po[0],siz);
 waveOutWrite(z1,@po[1],siz);

 trig2:=true;
 CreateThread(nil,0,@PlayProc,nil,0,Thr2);

 trig:=true;
 CreateThread(nil,0,@CalcProc,nil,0,Thr);
 SetThreadPriority(Thr,THREAD_PRIORITY_HIGHEST);
 ShowWindow(MainWnd,SW_SHOWMAXIMIZED); 

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
